"
    Copyright (C) 2015-now Jan Vrany

    This code is not an open-source (yet). You may use this code
    for your own experiments and projects, given that:

    * all modification to the code will be sent to the
      original author for inclusion in future releases
    * this is not used in any commercial software

    This license is provisional and may (will) change in
    a future.
"
"{ Package: 'jv:tea/compiler' }"

"{ NameSpace: Smalltalk }"

RBMessageNode subclass:#TSpecialFormNode
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Languages-Tea-Compiler-AST'
!

!TSpecialFormNode class methodsFor:'documentation'!

copyright
"
    Copyright (C) 2015-now Jan Vrany

    This code is not an open-source (yet). You may use this code
    for your own experiments and projects, given that:

    * all modification to the code will be sent to the
      original author for inclusion in future releases
    * this is not used in any commercial software

    This license is provisional and may (will) change in
    a future.
"
!

documentation
"
    TSpecialNode

    [author:]
        Jan Vrany <jan.vrany@fit.cvut.cz>

    [instance variables:]

    [class variables:]

    [see also:]

"
! !

!TSpecialFormNode class methodsFor:'instance creation'!

receiver: receiver selectorParts: keywordTokens arguments: arguments              
  ^self new 
        receiver: receiver
        selectorParts: keywordTokens
        arguments: arguments

    "Created: / 14-09-2015 / 12:27:53 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!TSpecialFormNode class methodsFor:'accessing'!

specialSelectors
    ^ #( ifTrue: ifTrue:ifFalse: whileTrue: )

    "Created: / 14-09-2015 / 12:22:35 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!TSpecialFormNode methodsFor:'testing'!

isSpecialFormNode
    ^ true

    "Created: / 14-09-2015 / 12:16:25 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!TSpecialFormNode methodsFor:'visiting'!

acceptVisitor: aProgramNodeVisitor 
    ^aProgramNodeVisitor acceptSpecialFormNode: self

    "Created: / 14-09-2015 / 12:09:26 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

